/*--------------------------------------------------------------------------------*\
\*--------------------------------------------------------------------------------*/
#ifndef __linux_pcmlink_ul_h__
#define __linux_pcmlink_ul_h__

#include <linux/types.h> 
#include <linux/module.h> 
#include <linux/sched.h> 
#include <linux/interrupt.h>
#include <linux/slab.h> 

/*------------------------------------------------------------------------------------------*\
\*------------------------------------------------------------------------------------------*/
enum _logic_chan_ul {
	logic_chan_controlchan     = 0,       /*--- wird vom ul-proto (zuerst) aufgebaut: dient zum Lifettime-check, Debug, ul_release ... ---*/ 
    logic_chan_Messages        = 1,
	logic_chan_D_Kanal_TE      = 2,
	logic_chan_D_Kanal_NT      = 3,
	logic_chan_AnalogPOTS      = 4, /*---- pots ---*/    
	logic_chan_AnalogAB1       = 5, /*---- slic1 ---*/
	logic_chan_AnalogAB2       = 6, /*---- slic2 ---*/
	logic_chan_AnalogAB3       = 7, /*---- slic3 ---*/
	logic_chan_B1_Kanal_TE     = 8,/*--- isdn-te1 ---*/
	logic_chan_B2_Kanal_TE     = 9,/*--- isdn-te2 ---*/
	logic_chan_B1_Kanal_NT     = 10,/*--- isdn-nt1 ---*/
	logic_chan_B2_Kanal_NT     = 11,/*--- isdn-nt2 ---*/
	logic_chan_DECT_Kanal_1    = 12,/*--- dect ---*/
	logic_chan_DECT_Kanal_2    = 13,/*--- dect ---*/
	logic_chan_DECT_Kanal_3    = 14,/*--- dect ---*/
	logic_chan_DECT_Kanal_4    = 15,/*--- dect ---*/
    logic_chan_MaxChan         = 16 
};
#define PCMLINK_FIRST_DYNHW_CHAN   32  
#define PCMLINK_MAX_DYNHW_CHAN      3
/*-------------------------------------------------------------------------------------*\
\*-------------------------------------------------------------------------------------*/
enum _chan_message_voip_config {
    voip_chanx_off           = 0,
    voip_chanx_8khz          = 1,
    voip_chanx_8khz_only_rcv = 2
};

/*-------------------------------------------------------------------------------------*\
 * derzeitiges Format der Daten im logic_chan_Messages
\*-------------------------------------------------------------------------------------*/
struct _chan_message_voip {
    enum _logic_chan_ul ManhattanChan     :  5;
    enum _chan_message_voip_config Config :  2;
    unsigned int EchoCanceler             :  1;
    unsigned int Chanx_16khz              :  1; /*--- statt 8 kHz 16 kHz ---*/
    unsigned int Reserved                 : 23;
};
/*--------------------------------------------------------------------------------*\
\*--------------------------------------------------------------------------------*/
struct _chan_message_dsptomips {
    unsigned int TriggerCount;
    unsigned int DSP_XDU;
    unsigned int DSP_OVR;
    unsigned int MIPS_OVR;
    unsigned int ulRxMask;
    /*--- variable Anzahl _chan_dtmf; ---*/
};

/*--------------------------------------------------------------------------------*\
\*--------------------------------------------------------------------------------*/
struct _chan_dtmf {
#ifdef __BIG_ENDIAN
    enum _logic_chan_ul ManhattanChan:5;
    unsigned char Next:3;               /*--- 1 = es existiert Nachfolge-Element ---*/
#else/*--- #ifdef __BIG_ENDIAN ---*/
    unsigned char Next:3;               /*--- 1 = es existiert Nachfolge-Element ---*/
    enum _logic_chan_ul ManhattanChan:5;
#endif/*--- #else ---*//*--- #ifdef __BIG_ENDIAN ---*/
    unsigned char DTMF_Sign;
};

/*-------------------------------------------------------------------------------------*\
 * als Alternative zu _chan_message_dsptomips (Config-Info beim Startup)
 * (identisch mit der Struktur im fpgmemshared aber eben exportiert)
\*-------------------------------------------------------------------------------------*/
struct _chan_configmsg_dsptomips {
    unsigned int SupportFlag;
    unsigned int svnVersion;       
    unsigned int Reserved1;
    unsigned int Reserved2;
    unsigned int Flag;         /*--- muss -1 sein, zur Erkennung, dass keine struct _chan_message_dsptomips ---*/
};
#define PCMBUS_FPGA_DECTSLIC        0x1

#define PCMBUS_VERSION(a)       ((((a)->SupportFlag) >> 29) & 0x07)
#define PCMBUS_DTMF_SUPPORT(a)  ((((a)->SupportFlag) >> 28) & 0x01)
#define PCMBUS_MAX_AUDIOCHAN(a) ((((a)->SupportFlag) >> 26) & 0x03)
#define PCMBUS_MAX_ECCHAN(a)    ((((a)->SupportFlag) >> 22) & 0x0F)
#define PCMBUS_MAX_CODECCHAN(a) ((((a)->SupportFlag) >> 17) & 0x1F)
#define PCMBUS_MAX_NTCHAN(a)    ((((a)->SupportFlag) >> 13) & 0x0F)
#define PCMBUS_MAX_TECHAN(a)    ((((a)->SupportFlag) >>  9) & 0x0F)
#define PCMBUS_MAX_DECTCHAN(a)  ((((a)->SupportFlag) >>  5) & 0x0F)
#define PCMBUS_MAX_SLICCHAN(a)  ((((a)->SupportFlag) >>  2) & 0x07)
#define PCMBUS_MAX_POTSCHAN(a)  ((((a)->SupportFlag) >>  1) & 0x01)
#define PCMBUS_UK0(a)           ((((a)->SupportFlag) >>  0) & 0x01)

#endif/*--- #ifndef __linux_pcmlink_ul_h__ ---*/
